#pragma once

#include "CoreMinimal.h"
#include "BaseCharacterVelocityCalculationStrategy.h"
#include "TunableStat.h"
#include "TagStateBool.h"
#include "SurvivorReelVelocityAdditiveStrategy.generated.h"

class AKiller;

UCLASS(Blueprintable, meta=(BlueprintSpawnableComponent))
class THEGUNSLINGER_API USurvivorReelVelocityAdditiveStrategy : public UBaseCharacterVelocityCalculationStrategy
{
	GENERATED_BODY()

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FTunableStat _reelSpeed;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	float _minimumLinkLengthDelta;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	float _maximumVelocityAdditive;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, ReplicatedUsing=OnRep_OwningKiller, Transient, meta=(AllowPrivateAccess=true))
	AKiller* _owningKiller;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Replicated, meta=(AllowPrivateAccess=true))
	FTagStateBool _isBeingReeled;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Replicated, meta=(AllowPrivateAccess=true))
	FTagStateBool _isBeingPulled;

private:
	UFUNCTION(BlueprintCallable)
	void OnRep_OwningKiller();

public:
	virtual void GetLifetimeReplicatedProps(TArray<FLifetimeProperty>& OutLifetimeProps) const override;

public:
	USurvivorReelVelocityAdditiveStrategy();
};

FORCEINLINE uint32 GetTypeHash(const USurvivorReelVelocityAdditiveStrategy) { return 0; }
